package org.jopera.demo.data;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;

public class Loan implements Serializable {

	private Customer customer;
	
	private float amount;
	
	private Date start;
	private Date end;
	

	public Loan(float amount, Customer customer, String start, String end) {
		super();
		this.amount = amount;
		this.customer = customer;
		this.end = new Date(end);
		this.start = new Date(start);
	}

	public Customer getCustomer() {
		return customer;
	}

	public float getAmount() {
		return amount;
	}

	public Date getStart() {
		return start;
	}

	public Date getEnd() {
		return end;
	}

	public int getDuration() {
		
		Calendar c1 = Calendar.getInstance(); 
        Calendar c2 = Calendar.getInstance(); 
        c1.setTime(start);
        c2.setTime(end);
        
        return 12 * (c2.get(Calendar.YEAR) - c1.get(Calendar.YEAR)) + c2.get(Calendar.MONTH) - c1.get(Calendar.MONTH);
	}
	
	public float getRate() {
		
		float rate = 0.02f;
		
		int d = getDuration();
		
		if (d > 12)
			rate = rate - 0.001f;
		
		rate = rate * customer.getRating();
		
		return rate;
	}
	
	public boolean isValid() {
		return (getDuration() > 6 && getDuration() < 24) && (amount > 0) && (amount < 1000000);
	}
	
}
